// lzw_dictionary.h: interface for the lzw::dictionary class.
//////////////////////////////////////////////////////////////////////
#include <vector>
#include <map>
#include <iostream>

namespace lzw
{
    class dictionary
    {
    public:
        dictionary  (unsigned int heap_size_in_bytes, bool expanded);
        ~dictionary ();

        unsigned int    write_bytes     (char* buffer, size_t& index, size_t limit, unsigned int code) ;
        unsigned int    size            () ;
        bool            code_exists     (unsigned int code) ;
        unsigned int    get_entry       (unsigned int prefix, char letter) ;
        void            add_entry       (unsigned int prefix, char letter) ;
        void            reset           () ;

        unsigned int    get_prefix      (unsigned int entry) ;
        unsigned int    get_letter      (unsigned int entry) ;

        void            dump            () ;
        void            metrics         () ;

        // file must refer to a open file descriptor with the correct permissions
        bool            load_from_file  (int file) ;
        bool            save_to_file    (int file) ;

        void            dump_node       (size_t index) ;

    private:
        size_t          _node_count;
        size_t          _last_heap_index; // index of last item put into heap
        unsigned int*   _node_data;
        bool            _full;
        size_t          _heap_size; // in ints
        size_t          _max_nodes; // in nodes
        bool            _expanded; // if true, size returns _max_nodes instead of _node_count
    };
}
